// ==PREPROCESSOR==
// @import "%fb2k_path%\Themes\ModernUI\Scripts\Common.js"
// @import "%fb2k_path%\Themes\ModernUI\Scripts\PlaylistManager.js"
// @import "%fb2k_path%\Themes\ModernUI\Scripts\Lyrics.js"
// @import "%fb2k_path%\Themes\ModernUI\Scripts\Queue.js"
// @import "%fb2k_path%\Themes\ModernUI\Scripts\Search.js"
// @name "WSH ModernUI"
// @version "1.1"
// @author "Nadir >> http://nadir1.deviantart.com"
// @feature "v1.4"
// @feature "watch-metadb"
// @feature "dragdrop"
// ==/PREPROCESSOR==

seekbar = function (x, y, w, h, pad_left, pad_right) {
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.seekstart = pad_left;
	this.seekend = pad_right;
	this.timer = false;

	this.update = function (x, y, w, h, pad_left, pad_right) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		this.seekstart = pad_left;
		this.seekend = pad_right;
	}

	this.draw = function (gr, pos, alpha) {
		gr.FillSolidRect(this.x, this.y, this.w, this.h, setAlpha(g_textcolor, 50));
		gr.FillSolidRect(this.x, this.y, pos, this.h, blendColors(g_textcolor, g_backcolor, 0.0));

	}

	this.repaint = function () {
		window.RepaintRect(this.x, this.y, this.w, this.h);
	}

	this.checkstate = function (event, x, y, step) {
		this.ishover = (x > this.x && x < this.x + this.w - 1 && y > this.y && y < this.y + this.h - 1);
		this.old = this.state;
		switch (event) {
		case "down":

			break;
		case "up":

			break;
		case "right":

			break;
		case "move":
			this.ishover = (x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h);
			break;
		case "leave":

			break;
		case "wheel":
			if (this.ishover) {
				if (step > 0) {
					fb.RunMainMenuCommand("Playback/Seek/Ahead by 1 second");
				} else {
					fb.RunMainMenuCommand("Playback/Seek/Back by 1 second");
				}
				this.repaint();
			}
			break;
		}
		return this.ishover;
	}
}

volume_bar = function (vx, vy, vw, vh) {
	var v_drag,
	v_drag_hov,
	volpos,
	g_hover_vol = 0;

	this.pos2vol = function (pos) {
		return (50 * Math.log(0.99 * ((vy + vh + (vw / 2) - pos) / vh < 0 ? 0 : (vy + vh + (vw / 2) - pos) / vh) + 0.01) / Math.LN10);
	}

	this.vol2pos = function (v, w2) {
		return (w2 - Math.round(((Math.pow(10, v / 50) - 0.01) / 0.99) * w2));
	}

	this.vol2percentage = function (v) {
		var p = ((Math.pow(10, v / 50) - 0.01) / 0.99);
		return (p);
	}

	this.draw = function (gr) {

		var volume = fb.Volume;

		volpos = this.vol2pos(volume, vh);
		percentage = g_volume.vol2percentage(volume);
		vol_txt = Math.ceil(percentage * 100);

		if (g_hover_vol) {

			gr.FillSolidRect(vx - 22, vy - 52, vw + 44, vh + 84, blendColors(g_textcolor, g_backcolor, 0.8));

			gr.FillSolidRect(vx - 20, vy - 50, vw + 40, vh + 80, g_backcolor2);
			gr.FillSolidRect(vx, vy, vw, vh + vw, blendColors(g_textcolor, g_backcolor, 0.3));
			gr.FillSolidRect(vx, vy, vw, volpos + vw, blendColors(g_textcolor, g_backcolor, 0.85));
			gr.FillSolidRect(vx, vy + volpos, vw, vw, g_textcolor);

			gr.GdiDrawText(vol_txt, gdi.Font("Segoe UI", 14, 1), g_textcolor, vx - 10, vy - 40, vw + 20, 30, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}

		gr.GdiDrawText("VOL" + (g_hover_vol ? "" : " " + vol_txt), gdi.Font("Segoe UI", 14, 1), g_textcolor, vx - 25, vy + vh + 50, vw + 50, 30, DT_CENTER | DT_VCENTER | DT_SINGLELINE);

	}

	this.repaint = function (mode) {
		window.RepaintRect(vx, vy, vw, vh + vw);
		window.RepaintRect(vx - 25, vy - 52, vw + 50, vh + 124);
	}

	this.checkstate = function (event, x, y, step) {
		switch (event) {
		case "down":
			if (v_drag_hov) {
				v_drag = true;
				on_mouse_move(x, y);
			} else {
				v_drag = false;
			}
			break;
		case "up":
			v_drag = false;
			break;
		case "wheel":
			if (v_drag_hov) {
				if (step > 0)
					fb.VolumeUp();
				else
					fb.VolumeDown();
				this.repaint();
			}
			break;
		case "move":
			var hover = (x > vx - 5 && x < vx - 5 + vw + 10 && y > vy - 10 && y < vy - 10 + vh + 20);
			var hover2 = (x > vx - 25 && x < vx - 25 + vw + 50 && y > vy - 52 && y < vy - 52 + vh + 124);
			var hover3 = (x > vx - 25 && x < vx - 25 + vw + 50 && y > vy + vh + 50 && y < vy + vh + 80);

			if (v_drag) {
				g_hover_vol = true;
			} else {
				var tmp = g_hover_vol;
				if (hover3) {
					g_hover_vol = true;
				} else if (!hover2) {
					g_hover_vol = false;
				}
				if (g_hover_vol != tmp || g_hover_vol) {
					this.repaint();
				}
			}

			var tmp = v_drag_hov;
			if (hover && g_hover_vol) {
				v_drag_hov = true;
			} else {
				v_drag_hov = false;
			}
			if (tmp != v_drag_hov)
				this.repaint();

			if (v_drag) {
				var v = this.pos2vol(y);
				if (v <= -100)
					v = -100;
				if (v >= 0)
					v = 0;
				fb.Volume = v;
			}

			break;
		case "leave":
			g_hover_vol = false;
			this.repaint();
			break;
		}
	}
}

var ww = 0,
wh = 0;

var tf_artist = fb.TitleFormat("$if(%length%,$if2(%artist%,'Unknow Artist'),'Stream')");
var tf_album = fb.TitleFormat("$if(%length%,$if2(%album%,'Unknow Album'),'Web Radios')");
var tf_genre = fb.TitleFormat("[%genre%]");
var tf_path = fb.TitleFormat("[%directory%]");
var tf_title = fb.TitleFormat("[%title%]");

var tf_incollection = fb.TitleFormat("$if($day_of_month(%added%), IN COLLECTION, NOT IN COLLECTION)");

var g_genre, g_artist, g_album, g_incollection, g_title = "Unknow";

var seek_y = 0;
var seek_x = 0;
var seek_w = 0;
var g_seekbar = null;
var g_drag_seek = 0;
var g_drag = 0;
var tf_len = fb.Titleformat("[/%length%]");
var tf_elap = fb.TitleFormat("[%playback_time%]");
var tf_remain = fb.TitleFormat("[/'-'%playback_time_remaining%]");
var tf_len_seconds = fb.Titleformat("[%length_seconds%]");
var g_len = "0:00";
var g_elap = "0:00";
var g_remain = "0:00";
var g_drag_time;
var seek_font = gdi.Font("Segoe UI", 12, 0);
var g_elap_height;

var tf_x = 30;

var bt_play_y;
var bt_sep = 110;

var Tab_active = window.GetProperty("Tab Active", 0);

var cover_x = tf_x;
var cover_y = 0;
var CoverSize = 190;
var cover_img = null;
var ArtId = 0;

var artist_img = null;
var artistSize = window.GetProperty("Artist.Wallpaper.Size", 600);
var showArtist = window.GetProperty("Artist.Wallpaper.Show", true);
var ArtistAlpha = window.GetProperty("Artist.Wallpaper.Alpha", 210);

//---> Search
var myinputbox = new FormSimpleInput();

var marginx = 6;
var marginy = 6;

var normaltextcolour = g_textcolor;
var editbackcolour = blendColors(g_textcolor, g_backcolor, 0.94);
var edittextcolour = RGB(150, 154, 157);
var activecolour = RGB(0, 0, 0);
var selectcolour = RGB(255, 255, 255);

myinputbox.Open("Search", 36, 60, 160, gdi.Font("Segoe UI", 14, 0));

function on_size() {
	if (!window.Width || !window.Height) {
		return;
	}

	ww = window.Width;
	wh = window.Height;

	window.MinWidth = 330;
	window.MaxWidth = 330;

	if (Math.round((wh / 2) - 140) > 210) {
		cover_y = Math.round(wh / 2) - 140;
	} else {
		cover_y = 210;
	}

	seek_x = tf_x;
	seek_w = CoverSize;
	seek_y = cover_y + CoverSize + 14;
	seek_h = 4;

	if (!g_seekbar) {
		g_seekbar = new seekbar(seek_x, seek_y, seek_w, seek_h);
	} else {
		g_seekbar.update(seek_x, seek_y, seek_w, seek_h);
	}

	bt_play_y = 50;
	bt_play_x = tf_x + 8;

	g_volume = new volume_bar(ww - 60, wh - 200, 8, 90);

	pW = 300 - hPad * 2;
	pH = wh * 2;
	reset();

	lm = 0;
	rm = 0;
	tm = np_minH;
	bm = 0;

	MetaDB = fb.IsPlaying ? fb.GetNowPlaying() : fb.GetFocusItem();
	RefreshPlaylists();
	SetSlider();
	GetCoordinates();

	queue_mos();

	refresh_bt();

	Queue.offset = 0;
	Queue.limite = plman.GetPlaybackQueueCount() * Queue.row - wh + 40;

}

function on_init() {
	Scrollbar = new V_SCROLLBAR(scrollW, scrollH);
	ButtonAnimationTimer = new c_ButtonAnimationTimer();
	ScrollTimer = new c_ScrollTimer();
	InitButtons();
}
on_init();

function on_paint(gr) {

	gr.FillSolidRect(0, 0, ww, wh, g_backcolor);

	if (Tab_active == 0) {

		// Artist
		if (artist_img) {
			draw_image(gr, artist_img, 0, 0, ww, wh, "crop", InterpolationMode.HighQualityBilinear, 0, 255);
			gr.FillSolidRect(0, 0, ww, wh, setAlpha(g_backcolor, ArtistAlpha));
		}

		gr.FillSolidRect(cover_x, cover_y, CoverSize, CoverSize, setAlpha(g_textcolor, 20));

		if (cover_img) {
			this.cv_x = cover_x;
			this.cv_y = cover_y;
			this.cv_w = CoverSize;
			this.cv_h = CoverSize;
			if (cover_img.Height >= cover_img.Width) {
				this.ratio = cover_img.Width / cover_img.Height;
				this.pw = this.cv_w * this.ratio;
				this.ph = this.cv_h;
				this.left = Math.floor((this.ph - this.pw) / 2);
				this.top = 0;
				this.cv_x += this.left;
				this.cv_y += this.top;
				this.cv_w = this.cv_w - this.left * 2;
				this.cv_h = this.cv_h - this.top * 2;
			} else {
				this.ratio = cover_img.Height / cover_img.Width;
				this.pw = this.cv_w;
				this.ph = this.cv_h * this.ratio;
				this.top = Math.floor((this.pw - this.ph) / 2);
				this.left = 0;
				this.cv_x += this.left;
				this.cv_y += this.top;
				this.cv_w = this.cv_w - this.left * 2;
				this.cv_h = this.cv_h - this.top * 2;
			}

			gr.DrawImage(cover_img, this.cv_x, this.cv_y, this.cv_w, this.cv_h, 0, 0, cover_img.Width, cover_img.Height);

		} else if (cover_img === null) {
			gr.GdiDrawText("NO COVER", gdi.Font("SEGOE UI", 11, 0), blendColors(g_textcolor, g_backcolor, 0.5), cover_x, cover_y, CoverSize, CoverSize, DT_CENTER | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);

		} else {
			gr.GdiDrawText("LOADING", gdi.Font("SEGOE UI", 11, 0), blendColors(g_textcolor, g_backcolor, 0.5), cover_x, cover_y, CoverSize, CoverSize, DT_CENTER | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
		}

		try {
			gr.SetTextRenderingHint(3);

			tf_y = cover_y - 65;
			tf_w = 280;

			gr.GdiDrawText(g_genre, gdi.Font("Segoe UI", 10, 0), g_textcolor, tf_x, tf_y - 15, tf_w, 40, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);
			gr.GdiDrawText(g_artist, gdi.Font("Segoe UI", 24, 0), g_textcolor, tf_x, tf_y, tf_w, 40, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);
			gr.GdiDrawText(g_album, gdi.Font("Segoe UI", 16, 0), g_textcolor, tf_x, tf_y + 32, tf_w, 30, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);
			gr.GdiDrawText(g_title, gdi.Font("Segoe UI", 24, 0), g_textcolor, tf_x - 2, seek_y + 35, tf_w, 40, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);

			//gr.GdiDrawText(g_incollection.toLowerCase(), gdi.Font("Segoe UI", 10, 0), g_textcolor, cover_x, cover_y + CoverSize + 8, CoverSize, 30, DT_RIGHT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);

			txt_col2 = blendColors(g_textcolor, g_backcolor, 0.0);
			t2d = 20;
			t2sep = 60;

			gr.GdiDrawText(title_2, gdi.Font("Segoe UI", 10), txt_col2, tf_x + t2d, seek_y + t2sep + 20, CoverSize - t2d, 20, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);
			gr.GdiDrawText(title_3, gdi.Font("Segoe UI", 10), txt_col2, tf_x + t2d, seek_y + t2sep + 40, CoverSize - t2d, 20, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);
			gr.GdiDrawText(title_4, gdi.Font("Segoe UI", 10), txt_col2, tf_x + t2d, seek_y + t2sep + 60, CoverSize - t2d, 20, DT_LEFT | DT_CALCRECT | DT_TOP | DT_END_ELLIPSIS | DT_NOPREFIX);

		} catch (e) {}

		for (var i = 0; i < playback.buttons.length; i++) {
			switch (i) {
			case 0:
				// Play
				playback.buttons[i].draw(gr, bt_play_x + bt_sep, bt_play_y, 255);
				break;
			case 1:
				// Next
				playback.buttons[i].draw(gr, bt_play_x + bt_sep * 2, bt_play_y, 255);
				break;
			case 2:
				// Prev
				playback.buttons[i].draw(gr, bt_play_x, bt_play_y, 255);
				break;
			}
		}

		// Draw seekbar
		if (fb.PlaybackLength > 0) {
			if (g_drag) {
				pos = g_seekbar.w * g_drag_seek;
			} else {
				pos = g_seekbar.w * (fb.PlaybackTime / fb.PlaybackLength);
			}
		} else {
			pos = 0;
		}
		pos = pos < 0 ? 0 : pos;
		g_seekbar.draw(gr, pos, 175);

		//g_elap = Format_hms(g_elap, g_len.length);
		g_elap_width = gr.CalcTextWidth(g_elap + (fb.IsPlaying ? g_remain : g_len), seek_font);
		g_elap_height = gr.CalcTextHeight(g_elap + g_remain, seek_font);
		gr.GdiDrawText(g_elap + (fb.IsPlaying ? g_remain : g_len), seek_font, g_textcolor, tf_x, seek_y + 14, g_elap_width, g_elap_height, DT_LEFT | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);

		if (!artist_img) {
			gr.FillGradRect(0, wh - 100, ww, 70, 90, 0, g_backcolor);
			gr.FillSolidRect(0, wh - 30, ww, 30, g_backcolor);
		}

		g_volume.draw(gr);

	} else if (Tab_active == 1) {
		pos = a_active && fb.PlaybackLength > 0 ? g_offset - g_textheight * (fb.PlaybackTime / fb.PlaybackLength) : g_offset;
		g_need_calc ? calc() : gr.GdiDrawText(g_text, g_font_headers, blendColors(g_textcolor, g_backcolor, 0.0), hPad, pos, ww - hPad * 2, wh - pos, 2065);

		if (a_active && a_fader) {
			gr.FillGradRect(0, 0, ww, 100, 90, g_backcolor2, 0);
			gr.FillGradRect(0, wh - 100, ww, 100, 90, 0, g_backcolor2);
		}

	} else if (Tab_active == 2) {

		if (Items.length == 0) {
			DefaultTextItem.Draw(gr);
		} else {
			for (var i = 0; i < Items.length; i++) {
				if (!dragitem || dragitem.id != Items[i].id) {
					Items[i].Draw(gr);
				}
			}
		}

		if (dragitem) {
			dragitem.Draw(gr);
		}

		Scrollbar.Draw(gr);

	} else if (Tab_active == 3) {

		var queue_total = plman.GetPlaybackQueueCount();
		var vbarr = plman.GetPlaybackQueueContents();
		var arr = vbarr.toArray();

		// Drag Items
		for (var i = 0; i < queue_total; i++) {
			/*if (i < 9)
			num = "0" + (i + 1);
			else
			num = i + 1;
			 */

			// draw stripes
			var parity = ((i / 2) == Math.floor(i / 2) ? 1 : 0);
			if (parity == 0)
				gr.FillSolidRect(Queue.x, Queue.y_pad + i * Queue.row - Queue.offset + 1, ww, Queue.row, RGBA(0, 0, 0, 5));

			gr.GdiDrawText(tf_title.EvalWithMetadb(arr[i].Handle), gdi.Font("segoe ui", 14), g_textcolor, Queue.x + 20, Queue.y_pad + i * Queue.row - Queue.offset - 4, ww - 60, Queue.row, DT_LEFT | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);

			//gr.GdiDrawText(num, gdi.Font("segoe ui", 15), RGB(0, 0, 0), 10, y_pad + i * row - 4 - offset, 20, row, DT_CENTER | DT_TOP | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);
			gr.GdiDrawText(tf_artist.EvalWithMetadb(arr[i].Handle), gdi.Font("segoe ui", 9), blendColors(g_textcolor, g_backcolor, 0.6), Queue.x + 20, Queue.y_pad + i * Queue.row - Queue.offset + 8, ww - 60, Queue.row, DT_LEFT | DT_TOP | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);

			try {
				clear.bt[i].draw(gr, ww - 30, Queue.y_pad + Math.round(Queue.row / 4) + i * Queue.row - Queue.offset, 255);
			} catch (e) {}

		}

		if (!queue_total)
			gr.GdiDrawText("empty", gdi.Font("segoe ui", 24), blendColors(g_textcolor, g_backcolor, 0.9), 0, 0, ww, wh - 150, DT_CENTER | DT_TOP | DT_VCENTER | DT_CALCRECT | DT_NOPREFIX | DT_SINGLELINE | DT_END_ELLIPSIS);

	} else if (Tab_active == 4) {
		myinputbox.draw(gr);

		var st_h = 40;

		for (var i = 0; i < SearchTag.buttons.length; i++) {
			switch (i) {
			case i:
				SearchTag.buttons[i].draw(gr, SearchTag.x, SearchTag.y + st_h * i, 255);
				break;
			}
		}
	}

}

var cover_hover = false;
var phover;

// mouse callbacks {{

function on_mouse_move(x, y) {

	if (Tab_active == 0) {

		// Cover
		cover_hover = (x > cover_x && x < cover_x + CoverSize && y > cover_y && y < cover_y + CoverSize);

		// Seekbar Seeker
		g_seekbar.checkstate("move", x, y);
		if (g_drag) {
			g_drag_seek = (x > g_seekbar.x && x < (g_seekbar.x + g_seekbar.w)) ? ((x - g_seekbar.x) / g_seekbar.w) : (x <= g_seekbar.x) ? 0 : 1;
			g_seekbar.repaint();
		}

		// Palyback
		for (var i = 0; i < playback.buttons.length; i++) {
			if (playback.buttons[i].checkstate("move", x, y) == ButtonStates.hover);
		}

		g_volume.checkstate("move", x, y);

	} else if (Tab_active == 1) {
		if (g_drag) {
			applyDelta(y - g_drag_y);
			g_drag_y = y;
		}

	} else if (Tab_active == 2) {

		if (y > 0 && y < (wh - (itemspace + row_height / 2)))
			if (dragitem && !dragitem.show) {
				destination = Math.floor(Math.min(Math.max((y - Y_OFFSET - tm + itemspace) / (itemspace + row_height), 0), fb.PlaylistCount - 1))

					if (dragitem.state != 2)
						dragitem.ChangeState(2);
					dragitem.y = Math.round(Math.min(Math.max(y - dragitem_y_rel - Y_OFFSET, 0), 9999));
				dragitem.closebtn.y = dragitem.y + row_height / 4;
				window.Repaint();

				SetSlider();
				if (NeedScrollbar && !ScrollTimerID) {
					if (y < (row_height + itemspace) * 1 && Y_OFFSET < 0) {
						direction = "up";
						ScrollTimer.Start();
					} else if (y > wh - (row_height + itemspace) * 1 && Y_OFFSET > -1 * scrollmax) {
						direction = "down";
						ScrollTimer.Start();
					}
				}
			} else if (!dbtn && !slider_drag) {
				for (i = 0; i < Items.length; i++) {
					if (Items[i].isXYok(x, y)) {
						if (hoveritem != Items[i]) {
							if (hoveritem)
								hoveritem.ChangeState(0);
							hoveritem = Items[i];
							hoveritem.ChangeState(1);

							if (g_handles != null) {
								var insert_index = fb.PlaylistItemCount(i);
								plman.InsertPlaylistItems(i, insert_index, g_handles, false);
							}
							g_handles = null;

						}
						break;
					}
				}
				if (i == Items.length) {
					if (hoveritem) {
						hoveritem.ChangeState(0);
						hoveritem = undefined;
					}
				}
			}

		if (slider_drag) {
			Scrollbar.slider.y = Math.min(Math.max(y - slider_y_rel, +0), wh - Scrollbar.slider.height);
			Y_OFFSET = Math.round(Math.min(Math.max(-1 * Scrollbar.step * Scrollbar.slider.y + 10, -1 * scrollmax), 0));
			window.Repaint();
		} else {
			if (Scrollbar.slider_isXYok(x, y)) {
				if (!slider_hover && !dbtn && !dragitem)
					slider_hover = true;
				window.RepaintRect(ww - 10, 0, 10, wh);
			} else if (slider_hover) {
				slider_hover = false;
				window.RepaintRect(ww - 10, 0, 10, wh);
			}
		}

		if (dbtn) {
			if (dbtn.isXYok(x, y)) {
				if (dbtn.state != 2)
					dbtn.ChangeState(2);
			} else if (dbtn.state != 1)
				dbtn.ChangeState(1);
		} else if (!dragitem && !slider_drag) {
			for (var i = 0; i < Items.length; i++) {
				if (Items[i].closebtn.isXYok(x, y)) {
					if (hbtn != Items[i].closebtn) {
						if (hbtn)
							hbtn.ChangeState(0);
						hbtn = Items[i].closebtn;
						hbtn.ChangeState(1);
					}
					break;
				}
			}
			if (i == Items.length) {
				if (hbtn) {
					hbtn.ChangeState(0);
					hbtn = undefined;
				}
			}
		}

		g_handles = null;
		mouse_y = y;

	} else if (Tab_active == 3) {

		var queue_total = plman.GetPlaybackQueueCount();

		for (var i = 0; i < queue_total; i++) {
			try {
				clear.bt[i].checkstate("move", x, y);
			} catch (e) {}
		}
	} else if (Tab_active == 4) {
		myinputbox.on_mousemove(x, y);
		for (var i = 0; i < SearchTag.buttons.length; i++) {
			if (SearchTag.buttons[i].checkstate("move", x, y) == ButtonStates.hover);
		}
	}

}

function on_mouse_leave() {

	if (Tab_active == 0) {
		// Playback
		for (var i = 0; i < playback.buttons.length; i++) {
			playback.buttons[i].checkstate("leave", 0, 0);
		}

		g_volume.checkstate("leave", 0, 0);

	} else if (Tab_active == 2) {
		if (hoveritem && !context_hover) {
			hoveritem.ChangeState(0);
			hoveritem = undefined;
		}

		if (slider_hover) {
			slider_hover = false;
			window.Repaint();
		}

		if (hbtn) {
			hbtn.ChangeState(0);
			hbtn = undefined;
		}
	} else if (Tab_active == 4) {

		for (var i = 0; i < SearchTag.buttons.length; i++) {
			SearchTag.buttons[i].checkstate("leave", 0, 0);
		}
	}

	window.Repaint();
}

function on_mouse_lbtn_down(x, y, mask) {

	if (Tab_active == 0) {

		// Seekbar
		if (x > g_seekbar.x && x < g_seekbar.x + g_seekbar.w && y > g_seekbar.y - 4 && y < g_seekbar.y + g_seekbar.h + 4) {
			if (fb.IsPlaying && fb.PlaybackLength)
				g_drag = true;
			g_drag_seek = (x > g_seekbar.x && x < (g_seekbar.x + g_seekbar.w)) ? ((x - g_seekbar.x) / g_seekbar.w) : (x <= g_seekbar.x) ? 0 : 1;
		}

		// Playback
		for (var i = 0; i < playback.buttons.length; i++) {
			playback.buttons[i].checkstate("down", x, y);
		}

		g_volume.checkstate("down", x, y);

	} else if (Tab_active == 1) {
		g_drag = true;
		g_drag_y = y;

	} else if (Tab_active == 2) {
		if (hbtn && !dbtn) {
			dbtn = hbtn;
			dbtn.ChangeState(2);
		}

		if (hoveritem && !dragitem && !dbtn) {
			dragitem = hoveritem;
			dragitem_y_rel = y - dragitem.y - Y_OFFSET;
			dragitem.ChangeState(2);
		}

		if (slider_hover && !slider_drag && !dbtn) {
			slider_drag = true;
			slider_y_rel = y - Scrollbar.slider.y;
			window.Repaint();
		}
	} else if (Tab_active == 3) {
		var queue_total = plman.GetPlaybackQueueCount();

		for (var i = 0; i < queue_total; i++) {
			try {
				clear.bt[i].checkstate("down", x, y);
			} catch (e) {}
		}
	} else if (Tab_active == 4) {
		myinputbox.on_mouse_lbtn_down(x, y);
		for (var i = 0; i < SearchTag.buttons.length; i++) {
			SearchTag.buttons[i].checkstate("down", 0, 0);
		}
	}

	window.Repaint();
}

function on_mouse_lbtn_up(x, y, mask) {

	if (Tab_active == 0) {

		// Seekbar
		if (g_drag | g_seekbar.ishover) {
			g_drag_seek = (x > g_seekbar.x && x < (g_seekbar.x + g_seekbar.w)) ? ((x - g_seekbar.x) / g_seekbar.w) : (x <= g_seekbar.x) ? 0 : 1;
			fb.PlaybackTime = fb.PlaybackLength * g_drag_seek;
			g_elap = tf_elap.Eval(true);
			g_drag = false;
		} else {
			// Cover
			if (cover_hover)
				window.NotifyOthers("showNowPlaying", "");

			g_drag = false;
		}

		// Playback
		for (var i = 0; i < playback.buttons.length; i++) {
			switch (i) {
			case 0:
				// Play
				if (playback.buttons[i].checkstate("up", x, y) == ButtonStates.hover) {
					fb.PlayOrPause();
					playback.buttons[i].state = ButtonStates.hover;
				}
				break;
			case 1:
				// Next
				if (playback.buttons[i].checkstate("up", x, y) == ButtonStates.hover) {
					fb.Next();
					playback.buttons[i].state = ButtonStates.hover;
				}
				break;
			case 2:
				// Prev
				if (playback.buttons[i].checkstate("up", x, y) == ButtonStates.hover) {
					fb.Prev();
					playback.buttons[i].state = ButtonStates.hover;
				}
				break;
			}
		}

		g_volume.checkstate("up", x, y);

	} else if (Tab_active == 1) {
		g_drag = false;

	} else if (Tab_active == 2) {
		if (dragitem) {
			if (dragitem.state == 2) {
				dragitem.ChangeState(1);
				dragitem.OnClick();
			}
			if (ScrollTimerID)
				ScrollTimer.Stop();
			dragitem = undefined;
			on_mouse_move(x, y);
		}

		if (slider_drag) {
			slider_drag = false;
		}

		if (dbtn) {
			if (dbtn.state == 2) {
				dbtn.ChangeState(1);
				dbtn.OnClick(x, y);
			}
			dbtn = undefined;
			on_mouse_move(x, y);
		}
	} else if (Tab_active == 3) {
		var queue_total = plman.GetPlaybackQueueCount();

		for (var i = 0; i < queue_total; i++) {
			try {
				if (clear.bt[i].checkstate("up", x, y) == ButtonStates.hover) {
					plman.RemoveItemFromPlaybackQueue(i);
					clear.bt[i].state = ButtonStates.hover;
				}
			} catch (e) {}
		}
	} else if (Tab_active == 4) {
		myinputbox.on_mouse_lbtn_up(x, y);

		for (var i = 0; i < SearchTag.buttons.length; i++) {
			if (SearchTag.buttons[i].checkstate("up", x, y) == ButtonStates.hover) {
				window.SetProperty("Tags Used", myinputbox.TagSearch = i);
				check_searchtag();
				myinputbox.func(myinputbox.Text);
				SearchTag.buttons[i].state = ButtonStates.hover;
			}
		}

	}

	window.Repaint();
}

function on_mouse_lbtn_dblclk() {}

function on_mouse_rbtn_down(x, y, vkey) {

	if (Tab_active == 2) {
		rbtnDown = true;
	}

}

function on_mouse_rbtn_up(x, y, mask) {

	if (Tab_active == 0) {

		for (var i = 0; i < playback.buttons.length; i++) {
			// Play
			if (playback.buttons[i].checkstate("up", x, y) == ButtonStates.hover) {
				playback_rbtn_up(x, y);
				return true;
				playback.buttons[i].state = ButtonStates.hover;
			}
		}

		Menu_Menu(x, y);

	} else if (Tab_active == 1 && fb.IsPlaying) {
		CustomMenuLyric(x, y);

	} else if (Tab_active == 2) {
		if (hoveritem) {
			if (rbtnDown) {
				rbtnDown = false;
				if (utils.IsKeyPressed(VK_SHIFT)) {
					return false; // if shift button pressed, show default context menu.
				} else {
					for (var i = 0; i < Items.length; i++) {
						if (Items[i].isXYok(x, y) && Items[i].id != "defaulttext") {
							cid = Items[i].id;
							break;
						}
					}
					if (i == Items.length)
						cid = -1;
					if (hoveritem && hoveritem.isXYok(x, y)) {
						context_hover = true;
					}

					playlist_context_menu(x, y, cid, true);

					return true;
				}
			}
		} else
			playlist_context_menu(x, y, false);
		return true;
	} else if (Tab_active == 3)
		queue_menu_context(x, y);
	else if (Tab_active == 4)
		myinputbox.on_mouse_rbtn_up(x, y);

	return true;
}

function on_mouse_wheel(step) {

	if (Tab_active == 0) {
		g_seekbar.checkstate("wheel", 0, 0, step);
		g_volume.checkstate("wheel", 0, 0, step);

	} else if (Tab_active == 1) {
		applyDelta(step * 20);

	} else if (Tab_active == 2) {
		if (NeedScrollbar && !dbtn && !dragitem) {
			if (hoveritem) {
				hoveritem.ChangeState(0);
				hoveritem = undefined;
			}
			Y_OFFSET = Math.floor(Math.min(Math.max(Y_OFFSET + step * (row_height + itemspace), -1 * (scrollmax)), 0));
			SetSlider();
			on_mouse_move();
			window.Repaint();
		}
	} else if (Tab_active == 3) {
		if ((plman.GetPlaybackQueueCount() * Queue.row) > (wh)) {

			Queue.limite = plman.GetPlaybackQueueCount() * Queue.row - wh;

			Queue.offset -= step * Queue.row;
			if (Queue.offset < 0)
				Queue.offset = 0;
			if (Queue.offset > Queue.limite)
				Queue.offset = Queue.limite;

			window.Repaint();
		}
	}

}

function on_mouse_mbtn_up(x, y) {

	if (Tab_active == 1) {
		reset();
		window.Repaint();
	}

}

// mouse callbacks }}

function on_key_down(vkey) {

	var mask = GetKeyboardMask();
	var act_pls = plman.ActivePlaylist;

	if (Tab_active == 4)
		myinputbox.on_key(vkey, mask);

	if (mask == KMask.none) {
		switch (vkey) {
		case VK_HOME:
			plman.SetPlaylistFocusItem(act_pls, 0);
			plman.ClearPlaylistSelection(act_pls);
			plman.SetPlaylistSelectionSingle(act_pls, 0, true);
			break;
		}
	} else {
		switch (mask) {
		case KMask.ctrl:
			if (vkey == 65) { // CTRL+A
				fb.RunMainMenuCommand("Edit/Select all");
				window.Repaint();
			}
			if (vkey == 70) { // CTRL+F
				fb.RunMainMenuCommand("Edit/Search");
			}
			if (vkey == 78) { // CTRL+N
				fb.RunMainMenuCommand("File/New playlist");
			}
			if (vkey == 79) { // CTRL+O
				fb.RunMainMenuCommand("File/Open...");
			}
			if (vkey == 80) { // CTRL+P
				fb.RunMainMenuCommand("File/Preferences");
			}
			if (vkey == 83) { // CTRL+S
				fb.RunMainMenuCommand("File/Save playlist...");
			}
			break;
		case KMask.alt:
			if (vkey == 65) { // ALT+A
				fb.RunMainMenuCommand("View/Always on Top");
			}
			break;
		}
	}
}

function on_char(code) {
	var mask = GetKeyboardMask();

	if (Tab_active == 4)
		myinputbox.on_char(code, mask);
}

function on_focus(is_focused) {
	if (Tab_active == 4 && !is_focused)
		myinputbox.on_focus(is_focused);
}

function on_volume_change(val) {

	if (Tab_active == 0) {
		g_volume.repaint();
	}

}

// drag and drop callbacks {{

var wsh_dragging = false;

function on_drag_enter(action, x, y) {

	if (Tab_active == 0) {
		wsh_dragging = true;

	} else if (Tab_active == 2) {
		dragging = true;
	}

}

function on_drag_leave() {

	if (Tab_active == 0) {
		wsh_dragging = false;

	} else if (Tab_active == 2) {
		dragging = false;
		on_mouse_leave();
	}

}

function on_drag_over(action, x, y, mask) {

	if (Tab_active == 0) {
		on_mouse_move(x, y);

	} else if (Tab_active == 2) {
		if (NeedScrollbar && !ScrollTimerID) {
			if (y < (row_height + itemspace) * 1 && Y_OFFSET < 0) {
				direction = "up";
				ScrollTimer.Start();
			} else if (y > wh - (row_height + itemspace) * 1 && Y_OFFSET > -1 * scrollmax) {
				direction = "down";
				ScrollTimer.Start();
			}
		}

		for (var i = 0; i < Items.length; i++) {
			if (Items[i].isXYok(x, y) && Items[i].id != "defaulttext") {
				cid = Items[i].id;
				if (hoveritem)
					hoveritem.ChangeState(0);
				hoveritem = Items[i];
				hoveritem.ChangeState(1);
				break;
			}
		}
		if (i == Items.length) {
			cid = -1;
			on_mouse_leave();
		}

		mouse_y = y;
		window.Repaint();
	}

}

function on_drag_drop(action, x, y, mask) {

	if (Tab_active == 0) {
		wsh_dragging = false;
		action.ToPlaylist();
		action.Playlist = plman.ActivePlaylist;
		action.ToSelect = false;

	} else if (Tab_active == 2) {
		if (cid == -1) {
			action.ToPlaylist();
			action.Playlist = fb.CreatePlaylist(Items.length, "");
			action.ToSelect = false;
		} else {
			action.ToPlaylist();
			action.Playlist = cid;
			action.ToSelect = false;
		}
		window.Repaint();
	}

}

// drag and drop callbacks }}

playback = {
	buttons : Array()
};

init_icons();

function init_icons() {
	var mood;
	var gb;

	b_col = g_textcolor;
	bc_col_off = g_textcolor;
	bc_col_ov = g_textcolor;
	bc_col_on = setAlpha(g_textcolor, 50);

	play_off = gdi.CreateImage(35, 35);
	gb = play_off.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(14, 11, 24, 18, 14, 24);
	gb.FillPolygon(b_col, 0, points);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_off);
	play_off.ReleaseGraphics(gb);

	play_ov = gdi.CreateImage(50, 50);
	gb = play_ov.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(14, 11, 24, 18, 14, 24);
	gb.FillPolygon(b_col, 0, points);
	gb.FillEllipse(1, 1, 32, 32, setAlpha(b_col, 50));
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_ov);
	play_ov.ReleaseGraphics(gb);

	play_on = gdi.CreateImage(50, 50);
	gb = play_on.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(14, 11, 24, 18, 14, 24);
	gb.FillPolygon(bc_col_on, 0, points);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_on);
	play_on.ReleaseGraphics(gb);

	pause_off = gdi.CreateImage(35, 35);
	gb = pause_off.GetGraphics();
	gb.FillSolidRect(12, 12, 4, 12, b_col);
	gb.FillSolidRect(19, 12, 4, 12, b_col);
	gb.SetSmoothingMode(2);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_off);
	pause_off.ReleaseGraphics(gb);

	pause_ov = gdi.CreateImage(35, 35);
	gb = pause_ov.GetGraphics();
	gb.FillSolidRect(12, 12, 4, 12, b_col);
	gb.FillSolidRect(19, 12, 4, 12, b_col);
	gb.SetSmoothingMode(2);
	gb.FillEllipse(1, 1, 32, 32, setAlpha(b_col, 50));
	gb.DrawEllipse(1, 1, 32, 32, 2.5, bc_col_ov);
	pause_ov.ReleaseGraphics(gb);

	pause_on = gdi.CreateImage(35, 35);
	gb = pause_on.GetGraphics();
	gb.FillSolidRect(12, 12, 4, 12, bc_col_on);
	gb.FillSolidRect(19, 12, 4, 12, bc_col_on);
	gb.SetSmoothingMode(2);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_on);
	pause_on.ReleaseGraphics(gb);

	next_off = gdi.CreateImage(35, 35);
	gb = next_off.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(12, 13, 19, 18, 12, 22);
	gb.FillPolygon(b_col, 0, points);
	points = Array(19, 13, 25, 18, 19, 22);
	gb.FillPolygon(b_col, 0, points);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_off);
	next_off.ReleaseGraphics(gb);

	next_ov = gdi.CreateImage(50, 50);
	gb = next_ov.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(12, 13, 19, 18, 12, 22);
	gb.FillPolygon(b_col, 0, points);
	points = Array(19, 13, 25, 18, 19, 22);
	gb.FillPolygon(b_col, 0, points);
	gb.FillEllipse(1, 1, 32, 32, setAlpha(b_col, 50));
	gb.DrawEllipse(1, 1, 32, 32, 2.5, bc_col_ov);
	next_ov.ReleaseGraphics(gb);

	next_on = gdi.CreateImage(50, 50);
	gb = next_on.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(12, 13, 19, 18, 12, 22);
	gb.FillPolygon(bc_col_on, 0, points);
	points = Array(19, 13, 25, 18, 19, 22);
	gb.FillPolygon(bc_col_on, 0, points);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_on);
	next_on.ReleaseGraphics(gb);

	prev_off = gdi.CreateImage(35, 35);
	gb = prev_off.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(16, 13, 9, 18, 16, 22);
	gb.FillPolygon(b_col, 0, points);
	points = Array(23, 13, 16, 18, 23, 22);
	gb.FillPolygon(b_col, 0, points);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_off);
	prev_off.ReleaseGraphics(gb);

	prev_ov = gdi.CreateImage(50, 50);
	gb = prev_ov.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(16, 13, 9, 18, 16, 22);
	gb.FillPolygon(b_col, 0, points);
	points = Array(23, 13, 16, 18, 23, 22);
	gb.FillPolygon(b_col, 0, points);
	gb.FillEllipse(1, 1, 32, 32, setAlpha(b_col, 50));
	gb.DrawEllipse(1, 1, 32, 32, 2.5, bc_col_ov);
	prev_ov.ReleaseGraphics(gb);

	prev_on = gdi.CreateImage(50, 50);
	gb = prev_on.GetGraphics();
	gb.SetSmoothingMode(2);
	points = Array(16, 13, 9, 18, 16, 22);
	gb.FillPolygon(bc_col_on, 0, points);
	points = Array(23, 13, 16, 18, 23, 22);
	gb.FillPolygon(bc_col_on, 0, points);
	gb.DrawEllipse(1, 1, 32, 32, 1.6, bc_col_on);
	prev_on.ReleaseGraphics(gb);

	playback.buttons.splice(0, playback.buttons.length);
	for (i = 0; i < 3; i++) {
		switch (i) {
		case 0:
			playback.buttons.push(new button(play_off, play_off, play_on));
			break;
		case 1:
			playback.buttons.push(new button(next_off, next_off, next_on));
			break;
		case 2:
			playback.buttons.push(new button(prev_off, prev_off, prev_on));
			break;
		}
	}
}

check_buttons();

function check_buttons() {
	for (i = 0; i < 5; i++) {
		switch (i) {
		case 0:
			if (!fb.IsPlaying || fb.IsPaused) {
				playback.buttons[i].update(play_off, play_off, play_on);
			} else if (fb.IsPlaying) {
				playback.buttons[i].update(pause_off, pause_off, pause_on);
			}
			break;
		}
	}
}

// playlist callbacks {{

function on_playlist_switch() {

	if (Tab_active == 0) {

		if (fb.IsPlaying)
			return;
		getdata(selectedItem());
	} else if (Tab_active == 2) {
		on_playlists_changed();
	}

}

function on_playlist_items_added(playlist) {

	if (Tab_active == 0) {
		if (!fb.IsPlaying) {
			getdata(selectedItem());
		}
	} else if (Tab_active == 2) {
		on_playlists_changed();
	}

}

function on_playlist_items_removed(playlist, new_count) {

	if (Tab_active == 0) {
		if (playlist == fb.ActivePlaylist && !new_count) {

			!fb.IsPlaying && nullArt();
			return;
		}
		if (fb.IsPlaying || (playlist != fb.ActivePlaylist))
			return;

		getdata(selectedItem());
	} else if (Tab_active == 2) {
		on_playlists_changed();
	}

}

function on_playlists_changed() {

	if (Tab_active == 2) {
		RefreshPlaylists();
		SetSlider();
		GetCoordinates();
		window.Repaint();
	}

}

// }}

function on_notify_data(name, info) {
	switch (name) {
	case "Tab_active":
		window.SetProperty("Tab Active", Tab_active = info);
		window.Repaint();
		break;
	case "WSH_playlist_drag_drop":
		g_handles = info;
		break;
	}
}

function on_playback_stop(reason) {

	if (reason != 2) {

		check_buttons();

		g_elap = "0:00";
		g_remain = "0:00";

		var metadb = selectedItem();

		if (metadb) {
			getdata(metadb);
		} else
			nullArt();
	}

	if (fileinfo)
		fileinfo.Dispose();

	if (g_timer) {
		g_timer.Dispose();
		g_timer = null;
	}

	if (reason != 2) {
		a_active = false;
		g_active = false;
		reset();
		repaintLyrics();
	}

}

function on_playback_starting(cmd, is_paused) {
	if (Tab_active == 0) {

		g_seekbar.repaint();
	}

	if (cmd == 6) {
		getdata(fb.GetNowPlaying());
	}
}

function on_playback_new_track(metadb) {
	check_buttons();
	g_elap = tf_elap.Eval(true);
	g_remain = tf_remain.Eval(true);

	getdata(metadb);

	reset();
	if (metadb)
		g_active = fb.PlaybackLength <= 0 || metadb.RawPath.indexOf("cdda://") == 0 || metadb.RawPath.indexOf("FOO_LASTFM") == 0 || !d_command ? false : true;
	a_active = a_scroll && g_text != g_nolyrics ? true : false;
	repaintLyrics();

	if (a_active) {
		if (g_timer) {
			g_timer.Dispose();
			g_timer = null;
		}
		g_timer = window.CreateTimerInterval(250);
	}

	window.Repaint();
}
if (fb.IsPlaying)
	on_playback_new_track(fb.GetNowPlaying());

function on_playlist_items_selection_change() {

	if (fb.IsPlaying)
		return;
	var metadb = selectedItem();
	if (metadb) {
		getdata(metadb);
	} else
		nullArt();

}

function on_playback_pause(state) {
	check_buttons();
	window.Repaint();
}

function on_timer(id) {
	if (Tab_active == 1)
		g_timer && repaintLyrics();
	else if (Tab_active == 4) {
		if (myinputbox.edit)
			if (!search_timerID) {
				search_timerID = window.SetInterval(function () {

						myinputbox.cvisible = !myinputbox.cvisible;
						window.RepaintRect(myinputbox.crpx, myinputbox.crpy, myinputbox.crpw, myinputbox.crph);
					}, 400);
			}
	}
}

function on_playback_time(time) {

	g_remain = tf_remain.Eval(true);
	g_elap = tf_elap.Eval(true);
	if (Tab_active == 0) {
		try {
			window.RepaintRect(seek_x, seek_y + 14, g_elap_width + 5, g_elap_height);
		} catch (e) {}

		g_seekbar.repaint();

	}

}

function on_playback_edited() {
	var a = g_text;
	get_text();

	if (g_text != a)
		on_playback_new_track(metadb);
}

function on_metadb_changed() {

	getdata(fb.IsPlaying ? fb.GetNowPlaying() : selectedItem());
}

function getTs(metadb) {

	total = 0;
	item = Array();
	hlist = Array();
	handlelist = null,
	nowplaying = 0;
	metadblist_selection = plman.GetPlaylistSelectedItems(plman.ActivePlaylist);

	if (fb.IsPlaying) {
		handlelist = plman.GetPlaylistItems(plman.PlayingPlaylist);
		nowplaying = plman.GetPlayingItemLocation();
		pid = nowplaying.PlaylistItemIndex;
	} else {
		handlelist = plman.GetPlaylistItems(plman.ActivePlaylist);
		pid = plman.GetPlaylistFocusItemIndex(plman.ActivePlaylist);
	}

	queue_total = plman.GetPlaybackQueueCount(),
	vbarr = plman.GetPlaybackQueueContents(),
	arr = vbarr.toArray();

	try {
		if (queue_total > 0) {
			title_2 = tf_title.EvalWithMetadb(arr[0].Handle);
		} else {
			title_2 = tf_title.EvalWithMetadb(handlelist.Item(pid + 1));
		}
	} catch (e) {
		title_2 = "";
	}
	try {
		if (queue_total > 1) {
			title_3 = tf_title.EvalWithMetadb(arr[1].Handle);
		} else {
			title_3 = tf_title.EvalWithMetadb(handlelist.Item(pid + 2));
		}
	} catch (e) {
		title_3 = "";
	}
	try {
		if (queue_total > 2) {
			title_4 = tf_title.EvalWithMetadb(arr[2].Handle);
		} else {
			title_4 = tf_title.EvalWithMetadb(handlelist.Item(pid + 3));
		}
	} catch (e) {
		title_4 = "";
	}

}

var title_2,
title_3,
title_4 = "";
var metadb = fb.IsPlaying ? fb.GetNowPlaying() : fb.PlaylistItemCount(fb.ActivePlaylist) > 0 ? fb.GetFocusItem() : false;

getdata(metadb);

function getdata(metadb) {

	if (!metadb)
		return;

	if (metadb) {

		g_genre = tf_genre.EvalWithMetadb(metadb);
		g_artist = tf_artist.EvalWithMetadb(metadb);
		g_album = tf_album.EvalWithMetadb(metadb);
		g_title = tf_title.EvalWithMetadb(metadb);
		g_len = tf_len.EvalWithMetadb(metadb);
		g_incollection = tf_incollection.EvalWithMetadb(metadb);

	}

	getTs(metadb);

	getAlbumArt(metadb);

	window.Repaint();

}

function on_playback_queue_changed(origin) {

	getdata(fb.IsPlaying ? fb.GetNowPlaying() : selectedItem());

	queue_mos();
}

function getAlbumArt(metadb) {

	if (metadb === null) {
		cover_img = null;
		window.Repaint();
	}
	if (!metadb)
		return;

	cover_img = false;

	utils.GetAlbumArtAsync(window.ID, metadb, ArtId);

	if (showArtist) {
		artist_img = false;
		utils.GetAlbumArtAsync(window.ID, metadb, AlbumArtId.artist);
	}

}

function on_get_album_art_done(metadb, art_id, image, image_path) {
	if (art_id < 4) {
		if (image) {
			if (image.Height >= image.Width) {
				this.size = image.Width / image.Height;
				this.newWidth = CoverSize * this.size;
				this.newHeight = CoverSize;
			} else {
				this.size = image.Height / image.Width;
				this.newWidth = CoverSize;
				this.newHeight = CoverSize * this.size;
			}
			image = image.Resize(this.newWidth, this.newHeight);

			cover_img = image;
		} else {
			cover_img = null;
		}
		window.RepaintRect(cover_x, cover_y, CoverSize, CoverSize);
	}

	if (art_id == AlbumArtId.artist) {
		if (image) {
			if (image.Height >= image.Width) {
				this.size = image.Width / image.Height;
				this.newWidth = artistSize * this.size;
				this.newHeight = artistSize;
			} else {
				this.size = image.Height / image.Width;
				this.newWidth = artistSize;
				this.newHeight = artistSize * this.size;
			}
			image = image.Resize(this.newWidth, this.newHeight, InterpolationMode.HighQualityBilinear);

			artist_img = image;
		} else {
			artist_img = null;
		}
		window.Repaint();
	}

}

function selectedItem() {

	var apl = plman.ActivePlaylist;
	var metadb = null;

	for (var i = 0, l = plman.PlaylistItemCount(apl); i != l; i++) {

		if (plman.IsPlaylistItemSelected(apl, i)) {
			metadb = plman.GetPlaylistItems(apl)
				.Item(i);
			break;
		}

	}

	return metadb;

}

function nullArt() {

	cover_img = null;
	window.RepaintRect(cover_x, cover_y, CoverSize, CoverSize);

}

function playback_rbtn_up(x, y) {
	var _menu = window.CreatePopupMenu();
	var idx;

	_menu.AppendMenuItem(MF_STRING, 1, "Stop After Current");
	_menu.CheckMenuItem(1, fb.StopAfterCurrent);
	_menu.AppendMenuItem(MF_STRING, 2, "Stop");
	_menu.AppendMenuItem(MF_SEPARATOR, 0, 0);
	_menu.AppendMenuItem(MF_STRING, 3, "Next");
	_menu.AppendMenuItem(MF_STRING, 4, "Previous");
	_menu.AppendMenuItem(MF_SEPARATOR, 0, 0);
	if (!fb.IsPaused && fb.IsPlaying) {
		_menu.AppendMenuItem(MF_STRING, 5, "Pause");
	} else {
		_menu.AppendMenuItem(MF_STRING, 6, "Play");
	}

	idx = _menu.TrackPopupMenu(x, y);
	switch (idx) {
	case 1:
		fb.RunMainMenuCommand("Playback/Stop After Current");
		break;
	case 2:
		fb.Stop();
		break;
	case 3:
		fb.Next();
		break;
	case 4:
		fb.Prev();
		break;
	case 5:
		fb.Pause();
		break;
	case 6:
		fb.Play();
		break;
	}

	_menu.Dispose();
	return true;
}

btxt = function (str, font, normal, hover, down) {
	this.w,
	this.h = 0;
	this.str = str;
	this.Font = font;
	this.col = Array(normal, hover, down);
	this.state = ButtonStates.normal;
	this.update = function (active) {
		this.active = active;
		this.repaint();
	}
	this.draw = function (gr, x, y) {
		this.x = x;
		this.y = y;

		//this.w = gr.CalcTextWidth(this.str, this.Font);
		//this.h = gr.CalcTextHeight(this.str, this.Font);
		this.w = 230;
		this.h = 30;
		if (this.active)
			this.Font = gdi.Font("Segoe UI", 12, 0);
		else
			this.Font = gdi.Font("Segoe UI", 12, 0);

		//gr.GdiDrawText(this.str, this.Font, this.col, this.x, this.y, this.w, this.h, DT_LEFT | DT_CALCRECT | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);

		if (this.active)
			gr.FillSolidRect(this.x, this.y - 5, 7, this.h + 10, setAlpha(g_textcolor, 30));

		gr.SetTextRenderingHint(5);
		gr.DrawString(this.str, this.Font, this.active ? this.col[ButtonStates.hover] : this.col[this.state], this.x + 30, this.y, this.w + 1, this.h, lc_stringformat);

	}
	this.display_context_menu = function (x, y, id) {};
	this.repaint = function () {
		window.RepaintRect(this.x, this.y, this.w, this.h);
	}
	this.checkstate = function (event, x, y) {
		this.ishover = (x > this.x && x < this.x + this.w - 1 && y > this.y && y < this.y + this.h - 1);
		this.old = this.state;
		switch (event) {
		case "down":
			switch (this.state) {
			case ButtonStates.normal:
			case ButtonStates.hover:
				this.state = this.ishover ? ButtonStates.down : ButtonStates.normal;
				break;
			};
			break;
		case "up":
			this.state = this.ishover ? ButtonStates.hover : ButtonStates.normal;
			break;
		case "right":
			if (this.ishover)
				this.display_context_menu(x, y, id);
			break;
		case "move":
			switch (this.state) {
			case ButtonStates.normal:
			case ButtonStates.hover:
				this.state = this.ishover ? ButtonStates.hover : ButtonStates.normal;
				break;
			};
			break;
		case "leave":
			this.state = this.isdown ? ButtonStates.down : ButtonStates.normal;
			break;
		}
		if (this.state != this.old)
			this.repaint();
		return this.state;
	}
}

SearchTag = {
	x : 0,
	y : 140,
	name : ["Standard", "All fields", "Artist", "Album", "Album artist", "Title", "Genre", "Year", "Filename", "Rating", "Directory"],
	font : gdi.Font("Segoe UI", 12, 0),
	active : window.GetProperty("Tab Active", 1),
	buttons : Array()
};

function mTxt() {

	col_off = setAlpha(g_textcolor, 100);
	col_ov = g_textcolor;
	col_on = setAlpha(g_textcolor, 30);

	for (i = 0; i < SearchTag.name.length; i++) {
		switch (i) {
		case i:
			SearchTag.buttons.push(new btxt(SearchTag.name[i], SearchTag.font, col_off, col_ov, col_on));
			break;
		}
	}
}
mTxt();

function check_searchtag() {
	for (i = 0; i < SearchTag.name.length; i++) {
		if (i == myinputbox.TagSearch) {
			SearchTag.buttons[i].update(true);
		} else {
			SearchTag.buttons[i].update(false);
		}
	}
}
check_searchtag();
